;Quest'opera e' stata rilasciata sotto la licenza Creative Commons
;Attribuzione-Non commerciale-Condividi allo stesso modo 2.5 Italia.
;
;Per leggere una copia della licenza visita il sito web
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ o spedisci una
;lettera a Creative Commons, 171 Second Street, Suite 300,
;San Francisco, California, 94105, USA.
;
;
;This work is licensed under the Creative Commons
;Attribution-Noncommercial-Share Alike 2.5 Italy License.
;
;To view a copy of this license, visit
;http://creativecommons.org/licenses/by-nc-sa/2.5/it/ or send a letter
;to Creative Commons, 171 Second Street, Suite 300, San Francisco,
;California, 94105, USA.

; ________________________________________________
; |    Include per gestione seriale 877 System   |
; |______________________________________________|
; |   Include File                               |
; |______________________________________________|
; |   Tipo      : INC                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 20/11/09                       |
; |______________________________________________|

;*******************************************************
;                          NOTE
;*******************************************************
;LA TRASMISSIONE CHE DECIDO DI USARE E' LA 8-N-1 (nessuna parita',
; un bit di stop)
;TXSTA
;00100100 : modo asincrono high speed, 8bit, tx abilitato
;
;RCSTA
;10010000 : modo asincrono, ricezione continua abilitata, address
;            detection disattivata, pulisce framing e overrun error
;
;SPBRG
;0x40 : frequenza = Fosc/(16*(SPBRG+1))= 19,2 KBAUD
;

;_______________________________________________________Costanti
#define c_SER_TXSTA       0x24              ;configurazione trasmissione seriale
#define c_SER_RCSTA       0x90              ;configurazione ricezione seriale
#define c_SER_SPBRG       0x40              ;configurazione baud rate seriale

#define c_SER_CMDR        0xA9              ;byte comando lettura
#define c_SER_CMDW        0x55              ;byte comando scrittura
#define c_SER_CMDWEXT     0x56              ;byte comando scrittura estesa (2 bytes indirizzo)
#define c_SER_CMDP        0xAD              ;byte comando ping

#define c_SER_ACKR        0x83              ;byte ack comando read
#define c_SER_ACKW        0xC3              ;byte ack comando write
#define c_SER_ACKNOW      0xC4              ;byte ack comando write non disponibile
#define c_SER_ACKWEXT     0xC5              ;byte ack comando write esteso
#define c_SER_ACKNOEXT    0xC6              ;byte ack comando write esteso non disponibile
#define c_SER_ACKP        0x03              ;byte ack comando ping
#define c_SER_ACKEND      0xAA              ;byte ack fine trasmissione
#define c_SER_ACKAO       0x1B              ;byte ack address OK
#define c_SER_ACKAE       0x2B              ;byte ack address ERROR
#define c_SER_ACKDO       0x33              ;byte ack data OK
#define c_SER_ACKDE       0x53              ;byte ack data ERROR
#define c_SER_ACKBE       0x5B              ;byte ack block ERROR
#define c_SER_ACKRE       0x57              ;byte ack receive ERROR
#define c_SER_ACKWO       0x67              ;byte ack write OK
#define c_SER_ACKWE       0xA7              ;byte ack write ERROR

;_______________________________________________________Variabili
	WORD w_SYS_CTL			    ;controllo sistema
        BYTE b_SER_DATA                     ;buffer dato
        BYTE b_SER_ADDR                     ;buffer indirizzo
        BYTE b_SER_CTL                      ;byte controllo seriale
        BYTE b_SER_BUFF                     ;buffer seriale

;_______________________________________________________FLAGS
#define f_SER_GO          w_SYS_CTL+1,2     ;Flag modalita' seriale attiva
#define f_SER_WAIT1       w_SYS_CTL+1,3     ;Flag seriale attesa 1 (reset seriale)
#define f_SER_WAIT2       w_SYS_CTL+1,4     ;Flag seriale attesa 2 (reset seriale)
#define f_SER_READ        b_SER_CTL,0       ;Flag seriale lettura
#define f_SER_WRITE       b_SER_CTL,1       ;Flag seriale scrittura
#define f_SER_LAST        b_SER_CTL,2       ;flag seriale ultimo byte
#define f_SER_STEP1       b_SER_CTL,3       ;Flag seriale step 1
#define f_SER_STEP2       b_SER_CTL,4       ;Flag seriale step 2
#define f_SER_STEP3       b_SER_CTL,5       ;Flag seriale step 3
#define f_SER_STEP4       b_SER_CTL,6       ;Flag seriale step 4
#define f_SER_OK          b_SER_CTL,7       ;Flag seriale chiusa correttamente
